;------------------------------------------------------
;  ECHO/ASM -- Program to redirect video output to
;  imitate the IBM bat file command of echo
;  SYNTAX -- ECHO ON -- Restores video output
;	     ECHO OFF -- Redirects vidoe output to nil
;------------------------------------------------------
;
*LIST OFF
*INCLUDE MACLIB/ASM
*LIST ON
;------------------------------------------------------
	ORG	3000H
START	LD	A,(HL)		;HL=>Command line
	AND	0DFH		;Covert to uppercase
	CP	'O'		;Must be cap "O"
	JR	NZ,SYNERR	;Go if not
	INC	HL		;HL==>nxt cmd line char
	LD	A,(HL)		;Get it
	AND	0DFH		;Make upper case
	CP	'F'		;Is par. off?
	JR	Z,VDOFF		;Yes--go
VDON	@@DSP	0EH		;Turn cursor on
	@@CMNDR	VIDON
	@@EXIT
VDOFF	@@CLS			;Clear screen
	@@DSP	0FH		;Turn cursor off
	@@CMNDR	VIDOFF		;Turn video off
	@@EXIT
;------------------------------------------------------
SYNERR	@@DSPLY	SYNMSG		;Display syntax message
	@@EXIT
;------------------------------------------------------
SYNMSG	DEFB	'Syntax error -- use ECHO ON or ECHO OFF',0DH
VIDON	DEFB	'RESET *DO',0DH
VIDOFF	DEFB	'ROUTE *DO (NIL)',0DH
;------------------------------------------------------
	END	START
